<template>
  <article class="view view--forum-topic-edit">
    <LoadingSpinner v-if="loading" />
    <TopicUpdateForm v-if="loaded" :topic="topic" />
  </article>
</template>

<script>
import { ref, computed, onMounted, watch } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { ValidationHelper, LoadingSpinner, useApi, useNotification } from '../../../core'
import { useAuth } from '../../../identity'
import TopicsApi from '../../api/topics-api.js'
import TopicUpdateForm from '../../components/topic-update-form.vue'

export default {
  name: 'ForumTopicEditView',
  components: {
    LoadingSpinner,
    TopicUpdateForm,
  },
  setup() {
    const route = useRoute()
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const topicsApi = new TopicsApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const topic = ref(undefined)

    const alias = computed(() => {
      return ValidationHelper.getString(route.params.alias, '')
    })

    const title = computed(() => {
      return 'Edit Topic'
    })

    const iconClass = computed(() => {
      return route.meta.iconClass
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Forum',
          route: { name: 'forum-forum' },
        },
        {
          text: topic.value?.section?.displayName || 'Section',
          route: topic.value?.section
            ? { name: 'forum-section', params: { codeName: topic.value.section.codeName } }
            : null,
        },
        {
          text: topic.value?.title || alias.value,
          route: alias.value ? { name: 'forum-topic', params: { alias: alias.value } } : null,
        },
        {
          text: title.value,
          route: null,
        },
      ]
    })

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      topic.value = null

      try {
        const response = await topicsApi.readAsync(alias.value, { expand: 'section' })
        topic.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the topic.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
    })

    watch(title, (val) => {
      store.dispatch('core/setTitle', val)
    })

    watch(breadcrumbs, (val) => {
      store.dispatch('core/setBreadcrumbs', val)
    })

    store.dispatch('core/setIconClass', iconClass.value)

    return {
      loading,
      loaded,
      topic,
    }
  },
}
</script>
